:- dynamic pos/1.
:- dynamic neg/1.


:- op(830,fx,rule).
:- op(780,xfx,::).
:- op(750,xfx,==>).
/*
rule(1,d1,[m1,m2,m3]).
rule(2,d2,[m3,m4]).
rule(3,m1,[b1,b2,b3]).
rule(4,m4,[b2,b4]).
*/
/*
rule(1,informatyka,[lubi_komputery,zna_angielski,mysli_analitycznie,mysli_po_inzyniersku]).
rule(2,gornictwo,w).
rule(3,mysli_analitycznie,[rozwiazuje_sudoku,planuje_w_kalendarzu]).
rule(4,mysli_po_inzyniersku,[dokreca_srubki,rysuje_technicznie]).
rule(5,kocha_slask,[mieszka_familiok,godo_gwaro]).
*/
rule 1 ::
[lubi_komputery,zna_angielski,mysli_analitycznie,mysli_po_inzyniersku] ==> informatyka.

rule 2 ::
[lubi_komputery,zna_angielski,mysli_analitycznie,mysli_po_inzyniersku] ==> gornictwo.

rule 3 ::
[rozwiazuje_sudoku,planuje_w_kalendarzu] ==> mysli_analitycznie.

rule 4 :: 
[dokreca_srubki,rysuje_technicznie] ==> mysli_po_inzyniersku.

rule 5 ::
[mieszka_familiok,godo_gwaro] ==> kocha_slask.



decision(D):-
%   rule(_,D,List),
   rule _ :: List ==> D,
   prove(List).
   
prove([]):-!.
prove([D|R]):- fact(D),prove(R).   

fact(D):- pos(D),!,write('Found in fact base: '),write(D),nl.
fact(D):- decision(D),assert(pos(D)),!,write('Proved and asserted: '),write(D),nl.
fact(D):- not(neg(D)), write('Is that true: '),write(D),write('? '),
          read(X),X='yes',assert(pos(D)),!,write('Declared positive: '), write(D),nl.

fact(D):- not(neg(D)),write('Then probably no? '),
          read(X),X='no',assert(neg(D)),!,write('Declared negative: '), write(D),fail.
fact(D):- not(pos(D)),not(neg(D)),
          write('Once more please: yes/no'),fact(D),!.         

clear:- retract(pos(_)),fail.
clear:- retract(neg(_)),fail.
clear.


